--- cfgloop.gcc45.s	2014-12-26 22:37:45.000000000 +0900
+++ cfgloop.gcc48.s	2014-12-26 22:25:31.000000000 +0900
@@ -8,24 +8,19 @@
 .LFB284:
 	.cfi_startproc
 	mov.l	@r5,r1
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
 	tst	r1,r1
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	bt.s	.L5
-	mov	r15,r14
-	bra	.L2
+	bt	.L5
 	mov.l	@(4,r1),r2
+	bra	.L7
+	cmp/eq	r2,r4
 .L5:
 	mov	#0,r2
-.L2:
 	cmp/eq	r2,r4
-	bt	.L3
-	mov	r4,r0
-	add	#2,r0
-	shll2	r0
-	mov.l	@(r0,r1),r1
+.L7:
+	bt.s	.L3
+	shll2	r4
+	add	r4,r1
+	mov.l	@(8,r1),r1
 	mov	#1,r0
 	bra	.L4
 	mov.l	r1,@r6
@@ -34,9 +29,8 @@
 	mov.l	r1,@r6
 	mov	#0,r0
 .L4:
-	mov	r14,r15
 	rts	
-	mov.l	@r15+,r14
+	nop
 	.cfi_endproc
 .LFE284:
 	.size	_ZL7ei_cond13edge_iteratorPP8edge_def, .-_ZL7ei_cond13edge_iteratorPP8edge_def
@@ -45,31 +39,25 @@
 _ZL15number_of_loopsv:
 .LFB318:
 	.cfi_startproc
-	mov.l	.L10,r1
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
+	mov.l	.L12,r1
 	mov.l	@r1,r1
 	mov.l	@(16,r1),r1
 	tst	r1,r1
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	bt.s	.L9
-	mov	r15,r14
+	bt	.L11
 	mov.l	@(4,r1),r1
 	tst	r1,r1
-	bt	.L9
+	bt	.L11
 	mov.l	@(4,r1),r0
-	bra	.L7
+	bra	.L9
 	nop
-.L9:
+.L11:
 	mov	#0,r0
-.L7:
-	mov	r14,r15
+.L9:
 	rts	
-	mov.l	@r15+,r14
-.L11:
+	nop
+.L13:
 	.align 2
-.L10:
+.L12:
 	.long	cfun
 	.cfi_endproc
 .LFE318:
@@ -79,24 +67,17 @@
 _ZL23loops_state_satisfies_pj:
 .LFB319:
 	.cfi_startproc
-	mov.l	.L13,r1
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
+	mov.l	.L15,r1
 	mov.l	@r1,r1
-	mov	r15,r14
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
 	mov.l	@(16,r1),r1
 	mov.l	@r1,r1
 	and	r4,r1
 	cmp/eq	r4,r1
-	movt	r0
-	mov	r14,r15
 	rts	
-	mov.l	@r15+,r14
-.L14:
+	movt	r0
+.L16:
 	.align 2
-.L13:
+.L15:
 	.long	cfun
 	.cfi_endproc
 .LFE319:
@@ -106,20 +87,13 @@
 _ZL14loop_exit_hashPKv:
 .LFB930:
 	.cfi_startproc
-	mov.l	.L16,r1
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
+	mov.l	.L18,r1
 	mov.l	@r1,r0
-	mov	r15,r14
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	mov.l	@r4,r4
-	mov	r14,r15
 	jmp	@r0
-	mov.l	@r15+,r14
-.L17:
+	mov.l	@r4,r4
+.L19:
 	.align 2
-.L16:
+.L18:
 	.long	htab_hash_pointer
 	.cfi_endproc
 .LFE930:
@@ -130,51 +104,12 @@
 .LFB931:
 	.cfi_startproc
 	mov.l	@r4,r1
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
 	cmp/eq	r5,r1
-	movt	r0
-	mov	r15,r14
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	mov	r14,r15
 	rts	
-	mov.l	@r15+,r14
+	movt	r0
 	.cfi_endproc
 .LFE931:
 	.size	_ZL12loop_exit_eqPKvS0_, .-_ZL12loop_exit_eqPKvS0_
-	.align 1
-	.type	_ZL10glb_enum_pPK15basic_block_defPKv, @function
-_ZL10glb_enum_pPK15basic_block_defPKv:
-.LFB923:
-	.cfi_startproc
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
-	mov	r4,r1
-	mov.l	@(8,r5),r6
-	cmp/eq	r6,r4
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	bt.s	.L20
-	mov	r15,r14
-	mov.l	.L21,r0
-	mov	#1,r4
-	mov	r1,r5
-	mov	r14,r15
-	jmp	@r0
-	mov.l	@r15+,r14
-.L20:
-	mov	#0,r0
-	mov	r14,r15
-	rts	
-	mov.l	@r15+,r14
-.L22:
-	.align 2
-.L21:
-	.long	_Z14dominated_by_p13cdi_directionPK15basic_block_defS2_
-	.cfi_endproc
-.LFE923:
-	.size	_ZL10glb_enum_pPK15basic_block_defPKv, .-_ZL10glb_enum_pPK15basic_block_defPKv
 	.section	.rodata.str1.4,"aMS",@progbits,1
 	.align 2
 .LC0:
@@ -185,91 +120,181 @@
 _ZL18dump_recorded_exitPPvS_:
 .LFB936:
 	.cfi_startproc
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
-	mov	#0,r2
 	sts.l	pr,@-r15
+	.cfi_def_cfa_offset 4
+	.cfi_offset 17, -4
+	add	#-4,r15
 	.cfi_def_cfa_offset 8
 	mov.l	@r4,r1
-	mov	r15,r14
-	.cfi_offset 17, -8
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	bra	.L24
+	mov	#0,r2
 	mov.l	@r1,r3
-.L25:
+.L23:
 	mov.l	@(12,r1),r1
-	add	#1,r2
-.L24:
 	tst	r1,r1
-	bf	.L25
-	mov.l	@r3,r1
-	add	#-4,r15
-	mov.l	.L26,r0
+	bf.s	.L23
+	add	#1,r2
+	mov.l	@r3,r7
 	mov	r5,r4
-	mov.l	@(44,r1),r6
 	mov.l	@(4,r3),r1
-	mov.l	.L27,r5
-	mov.l	@(44,r1),r7
-	.cfi_escape 0x2e,0x4
-	jsr	@r0
+	mov.l	.L24,r0
 	mov.l	r2,@r15
+	mov.l	.L25,r5
+	mov.l	@(44,r7),r6
+	jsr	@r0
+	mov.l	@(44,r1),r7
 	mov	#1,r0
-	mov	r14,r15
+	add	#4,r15
+	.cfi_def_cfa_offset 4
 	lds.l	@r15+,pr
+	.cfi_restore 17
+	.cfi_def_cfa_offset 0
 	rts	
-	mov.l	@r15+,r14
-.L28:
-	.align 2
+	nop
 .L26:
+	.align 2
+.L24:
 	.long	fprintf
-.L27:
+.L25:
 	.long	.LC0
 	.cfi_endproc
 .LFE936:
 	.size	_ZL18dump_recorded_exitPPvS_, .-_ZL18dump_recorded_exitPPvS_
 	.align 1
+	.type	_ZL8fel_nextP13loop_iteratorPP4loop, @function
+_ZL8fel_nextP13loop_iteratorPP4loop:
+.LFB322:
+	.cfi_startproc
+	mov.l	r8,@-r15
+	.cfi_def_cfa_offset 4
+	.cfi_offset 8, -4
+	mov.l	r9,@-r15
+	.cfi_def_cfa_offset 8
+	.cfi_offset 9, -8
+	sts.l	pr,@-r15
+	.cfi_def_cfa_offset 12
+	.cfi_offset 17, -12
+	mov.l	.L35,r7
+	mov	r4,r8
+	mov	r5,r9
+.L31:
+	mov.l	@r8,r4
+	tst	r4,r4
+	bt.s	.L28
+	mov.l	@(4,r8),r1
+	mov.l	@(4,r4),r2
+	cmp/hs	r2,r1
+	bt.s	.L29
+	mov	r1,r2
+	shll2	r2
+	add	r2,r4
+	add	#1,r1
+	mov.l	@(8,r4),r3
+	mov.l	r1,@(4,r8)
+	mov.l	@r7,r1
+	mov.l	@(16,r1),r1
+	mov.l	@(4,r1),r2
+	mov	r3,r1
+	shll2	r1
+	add	r2,r1
+	mov.l	@(8,r1),r1
+	tst	r1,r1
+	bt.s	.L31
+	mov.l	r1,@r9
+	bra	.L27
+	nop
+.L29:
+	mov.l	.L36,r1
+	jsr	@r1
+	nop
+	mov	#0,r1
+	mov.l	r1,@r8
+.L28:
+	mov	#0,r1
+	mov.l	r1,@r9
+.L27:
+	lds.l	@r15+,pr
+	.cfi_restore 17
+	.cfi_def_cfa_offset 8
+	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
+	rts	
+	mov.l	@r15+,r8
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
+.L37:
+	.align 2
+.L35:
+	.long	cfun
+.L36:
+	.long	free
+	.cfi_endproc
+.LFE322:
+	.size	_ZL8fel_nextP13loop_iteratorPP4loop, .-_ZL8fel_nextP13loop_iteratorPP4loop
+	.align 1
+	.type	_ZL10glb_enum_pPK15basic_block_defPKv, @function
+_ZL10glb_enum_pPK15basic_block_defPKv:
+.LFB923:
+	.cfi_startproc
+	mov.l	@(8,r5),r6
+	cmp/eq	r6,r4
+	bt.s	.L39
+	mov	r4,r1
+	mov.l	.L40,r0
+	mov	#1,r4
+	jmp	@r0
+	mov	r1,r5
+.L39:
+	rts	
+	mov	#0,r0
+.L41:
+	.align 2
+.L40:
+	.long	_Z14dominated_by_p13cdi_directionPK15basic_block_defS2_
+	.cfi_endproc
+.LFE923:
+	.size	_ZL10glb_enum_pPK15basic_block_defPKv, .-_ZL10glb_enum_pPK15basic_block_defPKv
+	.align 1
 	.type	_ZL14loop_exit_freePv, @function
 _ZL14loop_exit_freePv:
 .LFB932:
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
+	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 12
-	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 16
-	mov.l	.L32,r8
-	.cfi_offset 17, -16
-	.cfi_offset 14, -12
 	.cfi_offset 9, -8
-	.cfi_offset 8, -4
-	.cfi_def_cfa_register 14
-	bra	.L30
-	mov	r15,r14
-.L31:
-	mov.l	@(8,r4),r1
+	sts.l	pr,@-r15
+	.cfi_def_cfa_offset 12
+	.cfi_offset 17, -12
+	mov.l	.L46,r9
+.L43:
+	tst	r4,r4
+	bt	.L45
 	mov.l	@(4,r4),r2
-	mov.l	@(12,r4),r9
+	mov.l	@(8,r4),r1
+	mov.l	@(12,r4),r8
 	mov.l	r2,@(4,r1)
 	mov.l	@(4,r4),r2
-	jsr	@r8
+	jsr	@r9
 	mov.l	r1,@(8,r2)
-	mov	r9,r4
-.L30:
-	tst	r4,r4
-	bf	.L31
-	mov	r14,r15
+	bra	.L43
+	mov	r8,r4
+.L45:
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
-.L33:
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
+.L47:
 	.align 2
-.L32:
+.L46:
 	.long	_Z8ggc_freePv
 	.cfi_endproc
 .LFE932:
@@ -279,105 +304,53 @@
 _ZL25mfb_redirect_edges_in_setP8edge_def:
 .LFB917:
 	.cfi_startproc
-	mov.l	r14,@-r15
+	sts.l	pr,@-r15
 	.cfi_def_cfa_offset 4
+	.cfi_offset 17, -4
+	mov.l	.L49,r1
 	mov	r4,r5
-	mov.l	.L35,r1
-	mov.l	.L36,r0
-	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 8
-	mov.l	@r1,r4
-	.cfi_offset 17, -8
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
+	mov.l	.L50,r0
 	jsr	@r0
-	mov	r15,r14
+	mov.l	@r1,r4
 	tst	r0,r0
-	mov	#-1,r0
-	negc	r0,r0
-	extu.b	r0,r0
-	mov	r14,r15
+	movt	r0
+	xor	#1,r0
 	lds.l	@r15+,pr
+	.cfi_restore 17
+	.cfi_def_cfa_offset 0
 	rts	
-	mov.l	@r15+,r14
-.L37:
+	nop
+.L51:
 	.align 2
-.L35:
+.L49:
 	.long	_ZL12mfb_reis_set
-.L36:
+.L50:
 	.long	_Z20pointer_set_containsPK13pointer_set_tPKv
 	.cfi_endproc
 .LFE917:
 	.size	_ZL25mfb_redirect_edges_in_setP8edge_def, .-_ZL25mfb_redirect_edges_in_setP8edge_def
 	.align 1
-	.type	_ZL10loop_outerPK4loop.clone.13, @function
-_ZL10loop_outerPK4loop.clone.13:
+	.type	_ZL10loop_outerPK4loop.isra.13, @function
+_ZL10loop_outerPK4loop.isra.13:
 .LFB1100:
 	.cfi_startproc
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
 	tst	r4,r4
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	bt.s	.L41
-	mov	r15,r14
+	bt	.L55
+	mov.l	@(4,r4),r1
+	tst	r1,r1
+	bt.s	.L55
+	shll2	r1
+	add	r1,r4
+	bra	.L53
 	mov.l	@(4,r4),r0
-	tst	r0,r0
-	bt	.L41
-	add	#1,r0
-	shll2	r0
-	bra	.L39
-	mov.l	@(r0,r4),r0
-.L41:
+.L55:
 	mov	#0,r0
-.L39:
-	mov	r14,r15
+.L53:
 	rts	
-	mov.l	@r15+,r14
+	nop
 	.cfi_endproc
 .LFE1100:
-	.size	_ZL10loop_outerPK4loop.clone.13, .-_ZL10loop_outerPK4loop.clone.13
-	.section	.text._Z12sbitmap_freeP17simple_bitmap_def,"axG",@progbits,_Z12sbitmap_freeP17simple_bitmap_def,comdat
-	.align 1
-	.weak	_Z12sbitmap_freeP17simple_bitmap_def
-	.type	_Z12sbitmap_freeP17simple_bitmap_def, @function
-_Z12sbitmap_freeP17simple_bitmap_def:
-.LFB309:
-	.cfi_startproc
-	mov.l	r8,@-r15
-	.cfi_def_cfa_offset 4
-	mov.l	r9,@-r15
-	.cfi_def_cfa_offset 8
-	mov	r4,r9
-	.cfi_offset 9, -8
-	.cfi_offset 8, -4
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 12
-	mov.l	.L43,r8
-	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 16
-	mov.l	@r4,r4
-	.cfi_offset 17, -16
-	.cfi_offset 14, -12
-	.cfi_def_cfa_register 14
-	jsr	@r8
-	mov	r15,r14
-	mov	r9,r4
-	mov	r8,r1
-	mov	r14,r15
-	lds.l	@r15+,pr
-	mov.l	@r15+,r14
-	mov.l	@r15+,r9
-	jmp	@r1
-	mov.l	@r15+,r8
-.L44:
-	.align 2
-.L43:
-	.long	free
-	.cfi_endproc
-.LFE309:
-	.size	_Z12sbitmap_freeP17simple_bitmap_def, .-_Z12sbitmap_freeP17simple_bitmap_def
-	.text
+	.size	_ZL10loop_outerPK4loop.isra.13, .-_ZL10loop_outerPK4loop.isra.13
 	.align 1
 	.global	_Z18flow_loop_nested_pPK4loopS1_
 	.type	_Z18flow_loop_nested_pPK4loopS1_, @function
@@ -385,36 +358,31 @@
 .LFB899:
 	.cfi_startproc
 	mov.l	@(32,r4),r1
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
-	tst	r1,r1
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	bt.s	.L48
-	mov	r15,r14
-	bra	.L46
-	mov.l	@(4,r1),r0
-.L48:
-	mov	#0,r0
-.L46:
-	mov.l	@(32,r5),r1
 	tst	r1,r1
-	bt	.L50
+	bt	.L59
 	mov.l	@(4,r1),r2
-	cmp/hi	r0,r2
-	bf	.L50
-	add	#2,r0
-	shll2	r0
-	mov.l	@(r0,r1),r1
+	bra	.L62
+	mov.l	@(32,r5),r1
+.L59:
+	mov	#0,r2
+	mov.l	@(32,r5),r1
+.L62:
+	tst	r1,r1
+	bt	.L61
+	mov.l	@(4,r1),r3
+	cmp/hi	r2,r3
+	bf.s	.L61
+	shll2	r2
+	add	r2,r1
+	mov.l	@(8,r1),r1
 	cmp/eq	r4,r1
-	bra	.L47
+	bra	.L58
 	movt	r0
-.L50:
+.L61:
 	mov	#0,r0
-.L47:
-	mov	r14,r15
+.L58:
 	rts	
-	mov.l	@r15+,r14
+	nop
 	.cfi_endproc
 .LFE899:
 	.size	_Z18flow_loop_nested_pPK4loopS1_, .-_Z18flow_loop_nested_pPK4loopS1_
@@ -429,49 +397,47 @@
 _Z18superloop_at_depthP4loopj:
 .LFB900:
 	.cfi_startproc
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 8
+	.cfi_def_cfa_offset 4
+	.cfi_offset 17, -4
 	mov.l	@(32,r4),r1
 	tst	r1,r1
-	.cfi_offset 17, -8
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	bt.s	.L55
-	mov	r15,r14
-	bra	.L52
+	bt	.L67
 	mov.l	@(4,r1),r2
-.L55:
+	bra	.L73
+	cmp/hi	r2,r5
+.L67:
 	mov	#0,r2
-.L52:
 	cmp/hi	r2,r5
-	bf.s	.L53
+.L73:
+	bf.s	.L65
 	cmp/eq	r2,r5
-	mov.l	.L56,r1
-	mov.l	.L57,r4
-	mov.l	.L58,r6
+	mov.l	.L69,r1
+	mov.l	.L70,r4
+	mov.l	.L71,r6
 	jsr	@r1
 	mov	#79,r5
-.L53:
-	bt	.L54
-	mov	r5,r0
-	add	#2,r0
-	shll2	r0
-	mov.l	@(r0,r1),r4
-.L54:
+.L65:
+	bt.s	.L68
+	shll2	r5
+	add	r5,r1
+	bra	.L66
+	mov.l	@(8,r1),r0
+.L68:
 	mov	r4,r0
-	mov	r14,r15
+.L66:
 	lds.l	@r15+,pr
+	.cfi_restore 17
+	.cfi_def_cfa_offset 0
 	rts	
-	mov.l	@r15+,r14
-.L59:
+	nop
+.L72:
 	.align 2
-.L56:
+.L69:
 	.long	_Z11fancy_abortPKciS0_
-.L57:
+.L70:
 	.long	.LC1
-.L58:
+.L71:
 	.long	_ZZ18superloop_at_depthP4loopjE12__FUNCTION__
 	.cfi_endproc
 .LFE900:
@@ -484,48 +450,47 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	#0,r1
+	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov	r4,r8
 	.cfi_offset 9, -8
-	.cfi_offset 8, -4
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 12
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 16
+	.cfi_def_cfa_offset 12
+	.cfi_offset 17, -12
+	mov	#0,r1
 	mov.l	r1,@(32,r4)
 	mov	r4,r1
 	add	#64,r1
-	mov.l	@(32,r1),r1
-	mov	r15,r14
-	.cfi_offset 17, -16
-	.cfi_offset 14, -12
-	.cfi_def_cfa_register 14
-	bra	.L61
-	mov.l	@(8,r1),r4
-.L62:
-	mov.l	@(8,r4),r2
+	mov.l	@(32,r1),r2
+	mov	r4,r8
+	mov.l	@(8,r2),r4
+.L75:
+	cmp/eq	r2,r4
+	bt	.L77
+	mov.l	@(8,r4),r3
 	mov.l	r4,@(4,r4)
 	mov.l	r4,@(8,r4)
-	mov	r2,r4
-.L61:
-	cmp/eq	r1,r4
-	bf	.L62
-	mov.l	.L63,r9
+	bra	.L75
+	mov	r3,r4
+.L77:
+	mov.l	.L78,r9
 	jsr	@r9
 	nop
 	mov	r8,r4
 	mov	r9,r1
-	mov	r14,r15
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
+	.cfi_restore 8
 	jmp	@r1
 	mov.l	@r15+,r8
-.L64:
+	.cfi_def_cfa_offset 0
+.L79:
 	.align 2
-.L63:
+.L78:
 	.long	_Z8ggc_freePv
 	.cfi_endproc
 .LFE904:
@@ -538,62 +503,60 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
+	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov	r4,r9
 	.cfi_offset 9, -8
-	.cfi_offset 8, -4
 	mov.l	r10,@-r15
 	.cfi_def_cfa_offset 12
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 16
+	.cfi_offset 10, -12
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 20
+	.cfi_def_cfa_offset 16
+	.cfi_offset 17, -16
 	mov.l	@(4,r4),r1
 	tst	r1,r1
-	.cfi_offset 17, -20
-	.cfi_offset 14, -16
-	.cfi_offset 10, -12
-	.cfi_def_cfa_register 14
-	bt.s	.L65
-	mov	r15,r14
-	mov.l	.L72,r10
-	bra	.L67
+	bt.s	.L80
+	mov	r4,r9
+	mov.l	.L96,r10
 	mov	#0,r8
-.L71:
-	jsr	@r10
-	nop
-.L67:
+.L82:
 	mov.l	@(4,r9),r1
 	tst	r1,r1
-.L75:
-	bt	.L68
+	bt	.L83
 	mov.l	@(4,r1),r2
 	cmp/hs	r2,r8
-	bt.s	.L68
-	mov	r8,r0
-	add	#2,r0
-	shll2	r0
-	mov.l	@(r0,r1),r4
+	bt.s	.L83
+	mov	r8,r2
+	shll2	r2
+	add	r2,r1
+	mov.l	@(8,r1),r4
 	tst	r4,r4
-	bf.s	.L71
+	bt	.L84
+	jsr	@r10
+	nop
+.L84:
+	bra	.L82
 	add	#1,r8
-	bra	.L75
-	tst	r1,r1
-.L68:
+.L83:
 	mov	#0,r1
 	mov.l	r1,@(4,r9)
-.L65:
-	mov	r14,r15
+.L80:
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
-.L73:
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
+.L97:
 	.align 2
-.L72:
+.L96:
 	.long	_Z14flow_loop_freeP4loop
 	.cfi_endproc
 .LFE905:
@@ -606,45 +569,45 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	r4,r8
 	.cfi_offset 8, -4
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 8
-	mov.l	.L82,r0
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 12
-	mov	r15,r14
-	.cfi_offset 17, -12
-	.cfi_offset 14, -8
-	.cfi_def_cfa_register 14
+	.cfi_def_cfa_offset 8
+	.cfi_offset 17, -8
+	mov.l	.L104,r0
+	mov	r4,r8
 	jsr	@r0
 	mov.l	@(32,r4),r4
 	mov.l	@(36,r0),r1
 	cmp/eq	r8,r1
-	bf	.L81
+	bf	.L103
 	mov.l	@(40,r8),r1
-	bra	.L78
+	bra	.L100
 	mov.l	r1,@(36,r0)
-.L80:
-	mov	r2,r1
-.L81:
+.L103:
 	mov.l	@(40,r1),r2
+.L106:
 	cmp/eq	r8,r2
-	bf	.L80
+	bt	.L101
+	mov	r2,r1
+	bra	.L106
+	mov.l	@(40,r1),r2
+.L101:
 	mov.l	@(40,r8),r2
 	mov.l	r2,@(40,r1)
-.L78:
+.L100:
 	mov	#0,r1
 	mov.l	r1,@(32,r8)
-	mov	r14,r15
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
-.L83:
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
+.L105:
 	.align 2
-.L82:
-	.long	_ZL10loop_outerPK4loop.clone.13
+.L104:
+	.long	_ZL10loop_outerPK4loop.isra.13
 	.cfi_endproc
 .LFE909:
 	.size	_Z26flow_loop_tree_node_removeP4loop, .-_Z26flow_loop_tree_node_removeP4loop
@@ -656,42 +619,42 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	#100,r4
+	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 12
-	mov.l	.L85,r9
-	.cfi_offset 14, -12
 	.cfi_offset 9, -8
-	.cfi_offset 8, -4
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 16
-	.cfi_def_cfa_register 14
-	.cfi_offset 17, -16
+	.cfi_def_cfa_offset 12
+	.cfi_offset 17, -12
+	mov.l	.L108,r9
 	jsr	@r9
-	mov	r15,r14
+	mov	#100,r4
 	mov	r0,r8
 	jsr	@r9
 	mov	#16,r4
+	mov	r8,r2
+	add	#64,r2
 	mov	r8,r1
-	add	#64,r1
-	mov.l	r0,@(32,r1)
-	mov	#0,r2
+	mov.l	r0,@(32,r2)
+	add	#80,r1
 	mov.l	r0,@(4,r0)
-	add	#22,r1
 	mov.l	r0,@(8,r0)
+	mov	#0,r0
+	mov.b	r0,@(6,r1)
 	mov	r8,r0
-	mov.b	r2,@r1
-	mov	r14,r15
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
-.L86:
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
+.L109:
 	.align 2
-.L85:
+.L108:
 	.long	_Z31ggc_internal_cleared_alloc_statj
 	.cfi_endproc
 .LFE910:
@@ -704,114 +667,98 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	#0,r8
 	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov	r4,r9
 	.cfi_offset 9, -8
 	mov.l	r10,@-r15
 	.cfi_def_cfa_offset 12
+	.cfi_offset 10, -12
 	mov.l	r11,@-r15
 	.cfi_def_cfa_offset 16
+	.cfi_offset 11, -16
 	mov.l	r12,@-r15
 	.cfi_def_cfa_offset 20
-	mov.l	r13,@-r15
+	.cfi_offset 12, -20
+	sts.l	pr,@-r15
 	.cfi_def_cfa_offset 24
-	mov.l	r14,@-r15
+	.cfi_offset 17, -24
+	add	#-4,r15
 	.cfi_def_cfa_offset 28
-	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 32
-	add	#-8,r15
-	.cfi_def_cfa_offset 40
-	mov	r15,r14
-	.cfi_offset 17, -32
-	.cfi_offset 14, -28
-	.cfi_offset 13, -24
-	.cfi_offset 12, -20
-	.cfi_offset 11, -16
-	.cfi_offset 10, -12
-	.cfi_def_cfa_register 14
-	mov	r14,r10
-	mov.l	.L101,r11
-	bra	.L88
-	add	#-56,r10
-.L90:
-	mov.l	@(56,r10),r1
-	mov.l	@(24,r1),r0
-	and	#2,r0
+	mov.l	.L125,r11
+	mov	r4,r9
+	mov	#0,r8
+.L111:
+	mov	r8,r4
+	mov	r9,r5
+	jsr	@r11
+	mov	r15,r6
 	tst	r0,r0
-	bf.s	.L95
+	mov.l	.L125,r10
+	bt.s	.L123
+	mov.l	@(0,r15),r1
+	mov.l	@(24,r1),r0
+	tst	#2,r0
+	bt.s	.L111
 	add	#1,r8
-.L88:
+	bra	.L121
+	mov	#0,r0
+.L123:
+	mov.l	.L126,r11
+	mov	#0,r8
+	mov.l	.L127,r12
+.L115:
 	mov	r8,r4
 	mov	r9,r5
-	jsr	@r11
-	mov	r14,r6
+	jsr	@r10
+	mov	r15,r6
 	tst	r0,r0
-	bf.s	.L90
-	mov	r14,r13
-	bra	.L98
-	mov	r14,r11
-.L93:
-	mov.l	@(60,r11),r1
+	bt.s	.L121
+	mov.l	@(0,r15),r1
 	mov.l	@r1,r5
-	mov.l	@r10,r1
+	mov.l	@r11,r1
 	mov.l	@(4,r1),r1
 	mov.l	@r1,r1
 	cmp/eq	r1,r5
-	bt.s	.L92
+	bt.s	.L120
 	mov	#1,r4
-	mov.l	.L100,r1
-	jsr	@r1
+	jsr	@r12
 	mov	r9,r6
 	tst	r0,r0
-	bf.s	.L96
-	mov	#1,r0
-	bra	.L94
+	bf	.L121
+.L120:
+	bra	.L115
 	add	#1,r8
-.L94:
-	mov	r8,r4
-	mov	r9,r5
-	jsr	@r12
-	mov	r13,r6
-	tst	r0,r0
-	bf	.L93
-	bra	.L89
-	nop
-.L95:
-	mov	#0,r0
-.L96:
-.L89:
-	add	#8,r14
-	mov	r14,r15
+.L121:
+	add	#4,r15
+	.cfi_def_cfa_offset 24
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
-	mov.l	@r15+,r13
+	.cfi_restore 17
+	.cfi_def_cfa_offset 20
 	mov.l	@r15+,r12
+	.cfi_restore 12
+	.cfi_def_cfa_offset 16
 	mov.l	@r15+,r11
+	.cfi_restore 11
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
-.L98:
-	mov	#0,r8
-	add	#4,r13
-	mov.l	.L101,r12
-	mov.l	.L102,r10
-	bra	.L94
-	add	#-56,r11
-.L92:
-	bra	.L94
-	add	#1,r8
-.L103:
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
+.L128:
 	.align 2
-.L101:
+.L125:
 	.long	_ZL7ei_cond13edge_iteratorPP8edge_def
-.L100:
-	.long	_Z14dominated_by_p13cdi_directionPK15basic_block_defS2_
-.L102:
+.L126:
 	.long	cfun
+.L127:
+	.long	_Z14dominated_by_p13cdi_directionPK15basic_block_defS2_
 	.cfi_endproc
 .LFE912:
 	.size	_Z16bb_loop_header_pP15basic_block_def, .-_Z16bb_loop_header_pP15basic_block_def
@@ -821,41 +768,34 @@
 _Z21flow_bb_inside_loop_pPK4loopPK15basic_block_def:
 .LFB922:
 	.cfi_startproc
-	mov.l	.L109,r1
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
+	mov.l	.L134,r1
 	mov.l	@r1,r1
 	mov.l	@(4,r1),r1
 	mov.l	@r1,r2
 	cmp/eq	r2,r5
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	bt.s	.L107
-	mov	r15,r14
+	bt	.L132
 	mov.l	@(4,r1),r1
 	cmp/eq	r1,r5
-	bt	.L107
+	bt	.L132
 	mov.l	@(12,r5),r5
 	cmp/eq	r5,r4
-	bt	.L108
-	mov.l	.L110,r0
-	mov	r14,r15
+	bt	.L133
+	mov.l	.L135,r0
 	jmp	@r0
-	mov.l	@r15+,r14
-.L107:
-	bra	.L105
+	nop
+.L132:
+	bra	.L130
 	mov	#0,r0
-.L108:
+.L133:
 	mov	#1,r0
-.L105:
-	mov	r14,r15
+.L130:
 	rts	
-	mov.l	@r15+,r14
-.L111:
+	nop
+.L136:
 	.align 2
-.L109:
+.L134:
 	.long	cfun
-.L110:
+.L135:
 	.long	_Z18flow_loop_nested_pPK4loopS1_
 	.cfi_endproc
 .LFE922:
@@ -867,103 +807,118 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
+	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov	r7,r9
 	.cfi_offset 9, -8
-	.cfi_offset 8, -4
 	mov.l	r10,@-r15
 	.cfi_def_cfa_offset 12
-	mov	r4,r10
 	.cfi_offset 10, -12
 	mov.l	r11,@-r15
 	.cfi_def_cfa_offset 16
+	.cfi_offset 11, -16
 	mov.l	r12,@-r15
 	.cfi_def_cfa_offset 20
-	mov	r6,r12
 	.cfi_offset 12, -20
-	.cfi_offset 11, -16
 	mov.l	r13,@-r15
 	.cfi_def_cfa_offset 24
+	.cfi_offset 13, -24
 	mov.l	r14,@-r15
 	.cfi_def_cfa_offset 28
+	.cfi_offset 14, -28
 	sts.l	pr,@-r15
 	.cfi_def_cfa_offset 32
-	mov.l	.L119,r13
 	.cfi_offset 17, -32
-	.cfi_offset 14, -28
-	.cfi_offset 13, -24
-	mov	r15,r14
-	.cfi_def_cfa_register 14
-.L118:
-	mov.l	@r9,r1
-	mov	#1,r4
-	mov	#0,r11
+	mov.l	.L148,r13
+	mov	r4,r9
+	mov	r5,r8
+	mov	r6,r11
+	mov	r7,r10
+.L142:
+	mov.l	@r10,r1
+	mov	r8,r5
+	mov.l	.L149,r14
+	mov	r1,r2
 	mov	r1,r0
+	mov.l	.L150,r1
+	add	#1,r2
+	mov.l	r2,@r10
 	shll2	r0
-	mov.l	r5,@(r0,r12)
-	add	#1,r1
-	jsr	@r13
-	mov.l	r1,@r9
-	bra	.L113
-	mov	r0,r8
-.L115:
-	mov.l	.L120,r1
-	mov	r10,r4
+	mov.l	r8,@(r0,r11)
 	jsr	@r1
-	mov	r8,r5
-	tst	r0,r0
-	bt.s	.L114
 	mov	#1,r4
-	mov.l	.L121,r1
-	mov.l	@(12,r10),r5
-	jsr	@r1
-	mov	r8,r6
+	mov	r0,r12
+	mov	#0,r8
+.L138:
+	tst	r12,r12
+	bt.s	.L147
+	mov	r9,r4
+	jsr	@r13
+	mov	r12,r5
 	tst	r0,r0
-	bf.s	.L117
-	mov	r10,r4
-	mov.l	.L122,r1
-	mov	r8,r5
+	bt	.L139
+	mov	#1,r4
+	mov.l	@(12,r9),r5
+	jsr	@r14
 	mov	r12,r6
-	jsr	@r1
-	mov	r9,r7
-	bra	.L114
+	tst	r0,r0
+	bf	.L143
+	mov	r9,r4
+	mov.l	.L151,r2
+	mov	r12,r5
+	mov	r11,r6
+	jsr	@r2
+	mov	r10,r7
+	bra	.L139
 	nop
-.L117:
-	mov	r8,r11
-.L114:
-	mov.l	.L123,r1
-	mov	r8,r5
-	jsr	@r1
+.L143:
+	mov	r12,r8
+.L139:
+	mov.l	.L152,r0
+	mov	r12,r5
+	jsr	@r0
 	mov	#1,r4
-	mov	r0,r8
-.L113:
+	bra	.L138
+	mov	r0,r12
+.L147:
 	tst	r8,r8
-	bf.s	.L115
-	tst	r11,r11
-	bf.s	.L118
-	mov	r11,r5
-	mov	r14,r15
+	bf	.L142
 	lds.l	@r15+,pr
+	.cfi_restore 17
+	.cfi_def_cfa_offset 28
 	mov.l	@r15+,r14
+	.cfi_restore 14
+	.cfi_def_cfa_offset 24
 	mov.l	@r15+,r13
+	.cfi_restore 13
+	.cfi_def_cfa_offset 20
 	mov.l	@r15+,r12
+	.cfi_restore 12
+	.cfi_def_cfa_offset 16
 	mov.l	@r15+,r11
+	.cfi_restore 11
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
-.L124:
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
+.L153:
 	.align 2
-.L119:
-	.long	_Z13first_dom_son13cdi_directionP15basic_block_def
-.L120:
+.L148:
 	.long	_Z21flow_bb_inside_loop_pPK4loopPK15basic_block_def
-.L121:
+.L149:
 	.long	_Z14dominated_by_p13cdi_directionPK15basic_block_defS2_
-.L122:
+.L150:
+	.long	_Z13first_dom_son13cdi_directionP15basic_block_def
+.L151:
 	.long	_ZL17fill_sons_in_loopPK4loopP15basic_block_defPS3_Pi
-.L123:
+.L152:
 	.long	_Z12next_dom_son13cdi_directionP15basic_block_def
 	.cfi_endproc
 .LFE926:
@@ -974,34 +929,31 @@
 _Z23get_loop_body_with_sizePK4loopPP15basic_block_defj:
 .LFB924:
 	.cfi_startproc
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 4
-	mov	r4,r1
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 8
-	mov	r5,r7
-	mov	r15,r14
-	.cfi_offset 17, -8
-	.cfi_offset 14, -4
-	.cfi_def_cfa_register 14
-	mov.l	.L126,r0
+	.cfi_def_cfa_offset 4
+	.cfi_offset 17, -4
 	add	#-8,r15
-	mov.l	@(8,r4),r4
-	mov	#1,r5
+	.cfi_def_cfa_offset 12
 	mov.l	r6,@r15
-	mov.l	.L127,r6
-	.cfi_escape 0x2e,0x8
+	mov	r5,r7
+	mov.l	r4,@(4,r15)
+	mov	#1,r5
+	mov.l	.L155,r0
+	mov.l	.L156,r6
 	jsr	@r0
-	mov.l	r1,@(4,r15)
-	mov	r14,r15
+	mov.l	@(8,r4),r4
+	add	#8,r15
+	.cfi_def_cfa_offset 4
 	lds.l	@r15+,pr
+	.cfi_restore 17
+	.cfi_def_cfa_offset 0
 	rts	
-	mov.l	@r15+,r14
-.L128:
+	nop
+.L157:
 	.align 2
-.L126:
+.L155:
 	.long	_Z18dfs_enumerate_fromP15basic_block_defiPFbPKS_PKvEPS0_iS4_
-.L127:
+.L156:
 	.long	_ZL10glb_enum_pPK15basic_block_defPKv
 	.cfi_endproc
 .LFE924:
@@ -1014,113 +966,113 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	r4,r8
 	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 12
+	.cfi_offset 9, -8
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 16
+	.cfi_def_cfa_offset 12
+	.cfi_offset 17, -12
+	mov	r4,r8
 	mov.l	@(28,r4),r4
 	tst	r4,r4
-	.cfi_offset 17, -16
-	.cfi_offset 14, -12
-	.cfi_offset 9, -8
-	.cfi_def_cfa_register 14
-	bf.s	.L130
-	mov	r15,r14
-	mov.l	.L147,r4
-	mov.w	.L139,r5
-	bra	.L137
+	bf	.L159
+	mov.l	.L176,r4
+	mov.w	.L168,r5
+	bra	.L166
 	nop
-.L130:
-	mov.l	.L140,r0
+.L159:
+	mov.l	.L169,r0
 	jsr	@r0
 	shll2	r4
-	mov.l	.L141,r1
+	mov.l	.L170,r1
+	mov.l	@(12,r8),r7
+	mov.l	@r1,r2
+	mov.l	@(4,r2),r1
+	mov.l	@(4,r1),r3
+	cmp/eq	r3,r7
+	bf.s	.L160
 	mov	r0,r9
-	mov.l	@(12,r8),r3
-	mov.l	@r1,r1
-	mov.l	@(4,r1),r1
-	mov.l	@(4,r1),r2
-	cmp/eq	r2,r3
-	bf.s	.L131
-	mov.l	@(28,r8),r6
-	mov.l	@(12,r1),r2
-	cmp/eq	r2,r6
-	bt	.L132
-	mov.l	.L147,r4
-	mov.w	.L143,r5
-.L137:
-	mov.l	.L144,r1
-	mov.l	.L145,r6
+	mov.l	@(28,r8),r3
+	mov.l	@(12,r1),r1
+	cmp/eq	r1,r3
+	bt.s	.L161
+	mov	#2,r7
+	mov.l	.L176,r4
+	mov.w	.L172,r5
+.L166:
+	mov.l	.L173,r1
+	mov.l	.L174,r6
 	jsr	@r1
 	nop
-.L132:
-	mov.l	@(8,r8),r2
-	mov	r0,r3
-	add	#8,r3
-	mov.l	r2,@r0
-	mov.l	@(4,r1),r2
-	mov.l	r2,@(4,r0)
-	mov	#2,r0
-	mov.l	@r1,r2
-	bra	.L133
-	mov.l	@(28,r2),r2
-.L134:
-	mov.l	r2,@r3
-	add	#1,r0
-	mov.l	@(28,r2),r2
-	add	#4,r3
-.L133:
-	mov.l	@(4,r1),r7
-	cmp/eq	r7,r2
-	bf	.L134
-	mov.l	@(28,r8),r1
-	bra	.L151
-	cmp/eq	r1,r0
-.L131:
+.L161:
+	mov.l	@(8,r8),r1
+	mov.l	r1,@r0
+	mov.l	@(4,r2),r1
+	mov.l	@(4,r1),r1
+	mov.l	r1,@(4,r0)
+	mov.l	@(4,r2),r1
+	mov.l	@r1,r1
+	mov.l	@(28,r1),r1
+.L162:
+	mov.l	@(4,r2),r3
+	mov.l	@(4,r3),r3
+	cmp/eq	r3,r1
+	bt.s	.L164
+	mov	r7,r3
+	shll2	r3
+	mov	r3,r0
+	mov.l	r1,@(r0,r9)
+	add	#1,r7
+	bra	.L162
+	mov.l	@(28,r1),r1
+.L160:
 	mov	r0,r5
-	mov.l	.L146,r0
-	jsr	@r0
+	mov.l	.L175,r0
 	mov	r8,r4
+	jsr	@r0
+	mov.l	@(28,r8),r6
+	mov	r0,r7
+.L164:
 	mov.l	@(28,r8),r1
-	cmp/eq	r1,r0
-.L151:
-	bt	.L136
-	mov.l	.L147,r4
-	mov.w	.L148,r5
-	bra	.L137
-	nop
-.L136:
+	cmp/eq	r1,r7
+	bt.s	.L165
 	mov	r9,r0
-	mov	r14,r15
+	mov.l	.L176,r4
+	mov.w	.L177,r5
+	bra	.L166
+	nop
+.L165:
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
 	.align 1
-.L139:
+.L168:
 	.short	824
-.L143:
+.L172:
 	.short	832
-.L148:
+.L177:
 	.short	841
-.L149:
+.L178:
 	.align 2
-.L147:
+.L176:
 	.long	.LC1
-.L140:
+.L169:
 	.long	xmalloc
-.L141:
+.L170:
 	.long	cfun
-.L144:
+.L173:
 	.long	_Z11fancy_abortPKciS0_
-.L145:
+.L174:
 	.long	_ZZ13get_loop_bodyPK4loopE12__FUNCTION__
-.L146:
+.L175:
 	.long	_Z23get_loop_body_with_sizePK4loopPP15basic_block_defj
 	.cfi_endproc
 .LFE925:
@@ -1133,99 +1085,93 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
-	mov	r4,r8
 	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov.l	r10,@-r15
+	.cfi_offset 9, -8
+	sts.l	pr,@-r15
 	.cfi_def_cfa_offset 12
-	mov.l	r14,@-r15
+	.cfi_offset 17, -12
+	add	#-4,r15
 	.cfi_def_cfa_offset 16
-	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 20
+	mov	r4,r8
 	mov.l	@(28,r4),r4
-	add	#-4,r15
-	.cfi_def_cfa_offset 24
 	tst	r4,r4
-	.cfi_offset 17, -20
-	.cfi_offset 14, -16
-	.cfi_offset 10, -12
-	.cfi_offset 9, -8
-	.cfi_def_cfa_register 14
-	bf.s	.L153
-	mov	r15,r14
-	mov.l	.L166,r4
-	mov.w	.L158,r5
-	bra	.L156
+	bf	.L180
+	mov.l	.L193,r4
+	mov.w	.L185,r5
+	bra	.L183
 	nop
-.L153:
-	mov.l	.L159,r0
+.L180:
+	mov.l	.L186,r0
 	jsr	@r0
 	shll2	r4
-	mov.l	.L160,r1
+	mov.l	.L187,r1
 	mov.l	@(12,r8),r2
 	mov.l	@r1,r1
 	mov.l	@(4,r1),r1
 	mov.l	@(4,r1),r1
 	cmp/eq	r1,r2
-	bf.s	.L154
+	bf.s	.L181
 	mov	r0,r9
-	mov.l	.L166,r4
-	mov.w	.L162,r5
-.L156:
-	mov.l	.L163,r1
-	mov.l	.L164,r6
+	mov.l	.L193,r4
+	mov.w	.L189,r5
+.L183:
+	mov.l	.L190,r1
+	mov.l	.L191,r6
 	jsr	@r1
 	nop
-.L154:
-	mov	r14,r10
-	add	#-60,r10
+.L181:
 	mov	#0,r1
-	mov.l	r1,@(60,r10)
+	mov.l	r1,@(0,r15)
 	mov	r8,r4
-	mov.l	.L165,r1
+	mov.l	.L192,r1
 	mov	r0,r6
 	mov.l	@(8,r8),r5
 	jsr	@r1
-	mov	r14,r7
-	mov.l	@(60,r10),r2
+	mov	r15,r7
+	mov.l	@(0,r15),r2
 	mov.l	@(28,r8),r1
 	cmp/eq	r1,r2
-	bt.s	.L155
+	bt.s	.L182
 	mov	r9,r0
-	mov.l	.L166,r4
-	mov.w	.L167,r5
-	bra	.L156
+	mov.l	.L193,r4
+	mov.w	.L194,r5
+	bra	.L183
 	nop
-.L155:
-	add	#4,r14
-	mov	r14,r15
+.L182:
+	add	#4,r15
+	.cfi_def_cfa_offset 12
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
-	mov.l	@r15+,r10
+	.cfi_restore 17
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
 	.align 1
-.L158:
+.L185:
 	.short	884
-.L162:
+.L189:
 	.short	888
-.L167:
+.L194:
 	.short	893
-.L168:
+.L195:
 	.align 2
-.L166:
+.L193:
 	.long	.LC1
-.L159:
+.L186:
 	.long	xmalloc
-.L160:
+.L187:
 	.long	cfun
-.L163:
+.L190:
 	.long	_Z11fancy_abortPKciS0_
-.L164:
+.L191:
 	.long	_ZZ26get_loop_body_in_dom_orderPK4loopE12__FUNCTION__
-.L165:
+.L192:
 	.long	_ZL17fill_sons_in_loopPK4loopP15basic_block_defPS3_Pi
 	.cfi_endproc
 .LFE927:
@@ -1238,45 +1184,46 @@
 	.cfi_startproc
 	mov.l	r8,@-r15
 	.cfi_def_cfa_offset 4
+	.cfi_offset 8, -4
 	mov.l	r9,@-r15
 	.cfi_def_cfa_offset 8
-	mov	r5,r9
 	.cfi_offset 9, -8
-	.cfi_offset 8, -4
 	mov.l	r10,@-r15
 	.cfi_def_cfa_offset 12
-	mov	r4,r10
 	.cfi_offset 10, -12
-	mov.l	r14,@-r15
-	.cfi_def_cfa_offset 16
-	mov.l	.L170,r0
 	sts.l	pr,@-r15
-	.cfi_def_cfa_offset 20
-	.cfi_offset 17, -20
-	.cfi_offset 14, -16
-	.cfi_def_cfa_register 14
+	.cfi_def_cfa_offset 16
+	.cfi_offset 17, -16
+	mov.l	.L197,r0
+	mov	r4,r9
 	jsr	@r0
-	mov	r15,r14
-	mov.l	.L171,r1
+	mov	r5,r10
+	mov.l	.L198,r1
 	mov	r0,r8
-	mov.l	@(28,r10),r5
+	mov.l	@(28,r9),r5
 	mov	r0,r4
 	mov	#4,r6
 	jsr	@r1
-	mov	r9,r7
+	mov	r10,r7
 	mov	r8,r0
-	mov	r14,r15
 	lds.l	@r15+,pr
-	mov.l	@r15+,r14
+	.cfi_restore 17
+	.cfi_def_cfa_offset 12
 	mov.l	@r15+,r10
+	.cfi_restore 10
+	.cfi_def_cfa_offset 8
 	mov.l	@r15+,r9
+	.cfi_restore 9
+	.cfi_def_cfa_offset 4
 	rts	
 	mov.l	@r15+,r8
-.L172:
+	.cfi_def_cfa_offset 0
+	.cfi_restore 8
+.L199:
 	.align 2
-.L170:
+.L197:
 	.long	_Z13get_loop_bodyPK4loop
-.L171:
+.L198:
 	.long	qsort
 	.cfi_endproc
 .LFE928:
